// 002 u_c_variable_file
// 24 dec 2001

// -- (C) John COLIBRI 2001
// -- documentation: http://www.jcolibri.com

// -- file with (header, variable_part) and free_list

(*$r+*)

unit u_c_variable_file;
  interface
    uses u_c_basic_file;

    type t_variable_field_header= record
                                    m_record, m_field, m_length: Integer;
                                  end;

         c_variable_file= class(c_basic_file)
                            public
                              m_first_free_position: Integer;
                              m_variable_field_header: t_variable_field_header;

                              Constructor create_variable_file(p_name, p_file_name: String); Virtual;

                              function f_force_create: Boolean; Override;
                              procedure append_string(var pv_variable_field_header: t_variable_field_header;
                                  p_string: String; var pv_string_position: Integer);
                              procedure read_string(p_string_position: Integer;
                                  var pv_variable_field_header: t_variable_field_header;
                                  var pv_string: String);

                              Destructor Destroy; Override;
                          end;


  implementation
    uses SysUtils, Windows;

    // -- c_variable_file

    Constructor c_variable_file.create_variable_file(p_name, p_file_name: String);
      begin
        Inherited create_basic_file(p_name, p_file_name);
        m_name:= p_name;
      end; // create_variable_file

    function c_variable_file.f_force_create: Boolean;
      begin
        Inherited f_force_create;
        m_first_free_position:= 0;
        f_block_write(@ m_first_free_position, SizeOf(m_first_free_position));
        close_file;
        Result:= True;
      end; // create_file

    procedure c_variable_file.append_string(var pv_variable_field_header: t_variable_field_header;
        p_string: String; var pv_string_position: Integer);
      begin
        with pv_variable_field_header do
        begin
          m_length:= Length(p_string);

          seek_file(m_size);
          pv_string_position:= m_size;
          f_block_write(@ pv_variable_field_header, SizeOf(pv_variable_field_header));

          if m_length> 0
            then f_block_write(@ p_string[1], m_length);
        end; // with pv_variable_field_header
      end; // append_string

    procedure c_variable_file.read_string(p_string_position: Integer;
        var pv_variable_field_header: t_variable_field_header;
        var pv_string: String);
      begin
        // -- go to the end of the file
        seek_file(p_string_position);
        f_block_read(@ pv_variable_field_header, SizeOf(pv_variable_field_header));

        with pv_variable_field_header do
        begin
          if m_length> 0
            then begin
                SetLength(pv_string, m_length);
                f_block_read(@ pv_string[1], m_length);
              end;
        end; // with pv_variable_field_header
      end; // read_string

    Destructor c_variable_file.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_variable_file
    end. // u_c_variable_file
